class Nave:
	def __init__(self, x, y, dim, orientation): 
		# lista di tuple che contiene le posizioni occupate dalla nave
		self.pos = []
		# lista di tuple che contiene le posizioni colpite
		self.colpite = []

		self.orientation = orientation
		if orientation == "Horizontal":
			if dim > 0: # prua in x, y
				for i in range(x, x + dim):
					self.pos.append((i, y))
			elif dim < 0: # prua in (x + dim + 1, y), poppa in (x, y)
				for i in range(x + dim + 1, x + 1):
					self.pos.append((i, y))

		elif orientation == "Vertical":
			if(dim > 0): # prua in x, y
				for j in range(y, y + dim):
					self.pos.append((x, j))
			elif dim < 0: # prua in (x, y + dim + 1)
				for j in range(y + dim - 1, y + 1):
					self.pos.append((x, j))
				
	def collide(self, other):
		dim1 = len(self.pos)
		dim2 = len(other.pos)
		# controllo se ci sono due tuple uguali in pos di self e 
		# in pos di other: se si` , allora due navi si scontrano
		for tup in self.pos:
			for othertup in other.pos:
				if othertup == tup:
					return True

		return False #nessuna tupla uguale, nessuna intersezione

	def colpita(self, x, y):
		cell = (x, y)

		# il giocatore potrebbe avere colpito due volte nello stesso punto..
		# quindi non devo inserire tuple duplicate in self.colpite
		#
		if self.pos.count(cell) == 1 and self.colpite.count(cell) == 0:
			self.colpite.append(cell)
			return True

		return False

	def affondata(self):
		# in self.colpite avevo inserito solo tuple gia` contenute in 
		# self.pos e non ho inserito duplicati.
		# Pertanto basta confrontare le lunghezze
		#
		return len(self.pos) == len(self.colpite)
	
	def dimensione(self):
		return len(self.pos)

	def orizzontale(self):
		return self.orientation == "Horizontal"

