from nave import *
from random import randint

class Scacchiera:
	def __init__(self, dimX, dimY, numNavi):
		self.navi = [] 		# lista di navi
		self.dimX = dimX
		self.dimY = dimY
		mindim = min(dimX, dimY)
		self.nNavi = numNavi
		if numNavi > mindim:
			print("Il numero di navi e` stato ridotto a", mindim)
			self.nNavi = mindim

	# Genero navi di dimensione a partire da min(dimX, dimY)/2 (per evitare che debordino..)
	# Ogni due navi che genero, diminuisco la dimensione di uno.
	# In una scacchiera di 8x8 con 6 navi avro` quindi:
	# 2 navi da 4, 2 navi da 3 e 2 navi da 2 caselline..
	#
	def popolaScacchiera(self):
		numeroNavi = 0
		dimensioneNave = min(self.dimX, self.dimY) // 2

		while numeroNavi < self.nNavi:

			collisione = False
			# genero casualmente posizione x e y e orientazione della nave
			x = randint(0, self.dimX - 1)
			y = randint(0, self.dimY - 1)
			# orientazione
			h = randint(0, 1)
			# fattore moltiplicativo 1 o -1 per generare una nave con
			# diversa posizione della prua (vedi Nave)
			fattore = 1

			if h == 0:
				orientation = "Horizontal"
				if x > self.dimX // 2:
					fattore = -1	
			else:
				orientation = "Vertical"
				if y > self.dimY // 2:
					fattore = -1
			
			print("Creo nave" , x, y, fattore * dimensioneNave, orientation)
			nave = Nave(x, y, fattore * dimensioneNave, orientation)

			for n in self.navi:
				if n.collide(nave):
					collisione = True
					print("La nave", n.pos, "\033[1;31mcollide\033[0m con", nave.pos)
					break

			if not collisione:
				self.navi.append(nave)
				numeroNavi = numeroNavi + 1
				# ogni due navi, diminuisco la dimensione
				if numeroNavi % 2 == 0:
					dimensioneNave = dimensioneNave - 1


	def disegna(self):
		
		row = 0

		while row < self.dimY:
			# stampo il numero di riga
			print(row + 1, "\t|", end="")
			col = 0
			while col < self.dimX:
				cellaoccupata = False
				# creo tupla (row, col)
				tuplepos = (row, col)

				for nave in self.navi:
					if nave.pos.count(tuplepos) > 0:
						if nave.pos.index(tuplepos) == 0:
							if nave.orizzontale():
								print("\\", end="")
							else:
								print("/", end="")

						elif nave.pos.index(tuplepos) == len(nave.pos) - 1:
							if nave.orizzontale():
								print("/", end="")
							else:
								print("\\", end="")
						else:
							if nave.orizzontale():
								print("_", end="")
							else:
								print("|", end="")
#						if nave.orizzontale():
#							print("=", end="")
#						else:
#							print("+", end="")

						cellaoccupata = True
						break

				if not cellaoccupata:
					print(" ", end="")

				col = col + 1
			row = row  + 1
			print("") # a capo dopo una riga

		print("\t+", end="")
		for i in range(0, self.dimX):
			print("-", end="")

		print("\n\t ", end="") # a capo + tab + uno spazio

		for i in range(0, self.dimX):
			print(chr(ord('A') + i), end="")
		print("\n")

			
